SystemOrganization addCategory: #'Seaside-Gettext-Core'!

WAObject subclass: #WALazyTranslatedString
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Gettext-Core'!

!WALazyTranslatedString class methodsFor: 'instance creation' stamp: 'pmm 5/21/2011 16:43'!
key: aString
	^ self basicNew initializeWithKey: aString! !

!WALazyTranslatedString methodsFor: 'initialization' stamp: 'pmm 5/21/2011 16:43'!
initializeWithKey: aString
	self initialize.
	key := aString! !

!WALazyTranslatedString methodsFor: 'printing' stamp: 'pmm 5/21/2011 16:47'!
printOn: aStream
	key seasideTranslated printOn: aStream! !

!WALazyTranslatedString methodsFor: 'rendering' stamp: 'pmm 5/21/2011 16:45'!
renderOn: html
	html translate: key! !

WAObject subclass: #WALocalizationContext
	instanceVariableNames: 'domain translator localeId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Gettext-Core'!

!WALocalizationContext methodsFor: 'accessing' stamp: 'pmm 5/8/2010 21:41'!
defaultApplicationName
	^ 'defaultApplication'! !

!WALocalizationContext methodsFor: 'accessing' stamp: 'pmm 5/8/2010 22:13'!
domain
	domain isNil ifTrue: [
		"determine the domain name
		1. try if it is configured on the application
		2. use the application name
		3. send #defaultApplicationName"
		| configuredDomain |
		configuredDomain := [ self application gettextDomain ]
			on: WAAttributeNotFound
			do: [ :error | nil ].
		domain := configuredDomain isEmptyOrNil
			ifFalse: [ configuredDomain ]
			ifTrue: [
				| applicationName |
				applicationName := self application name.
				applicationName isEmptyOrNil
					ifFalse: [ applicationName ]
					ifTrue: [ self defaultApplicationName ] ] ].
	^ domain! !

!WALocalizationContext methodsFor: 'accessing' stamp: 'pmm 5/10/2010 22:37'!
fistSupportedLocaleWithFallback: aNiladicBlock
	| availableLanguageLocaleIDs |
	availableLanguageLocaleIDs := GetTextTranslator availableLanguageLocaleIDs.
	self requestContext request acceptLanguage do: [ :each |
		| locale |
		locale := each value.
		(availableLanguageLocaleIDs includes: locale asLocaleID)
			ifTrue: [ ^ locale ] ].
	^ aNiladicBlock value! !

!WALocalizationContext methodsFor: 'accessing' stamp: 'pmm 5/10/2010 22:38'!
localeId
	localeId isNil ifTrue: [
		| session |
		session := self session.
		self session notNil
			ifTrue: [
				"if there's a session take it from the session"
				localeId := session locale asLocaleID ]
			ifFalse: [
				"do language negotiation and take the first supported one"
				self requestContext acceptLanguage do: [ :each |
					| candidate |
					candidate := each value asLocaleID.
					GetTextTranslator translators
						at: candidate
						ifPresent: [ :t |
							translator := t.
							^ localeId := candidate ] ].
				"fall back to default"
				translator := GetTextTranslator default.
				localeId := translator localeID ] ].
	^ localeId! !

!WALocalizationContext methodsFor: 'translating' stamp: 'pmm 5/8/2010 21:50'!
translate: aString
	^ self translator
		translate: aString
		inDomain: self domain! !

!WALocalizationContext methodsFor: 'translating' stamp: 'pmm 5/8/2010 21:47'!
translate: aString to: aLocale
	^ (GetTextTranslator availableForLocaleID: aLocale asLocaleID)
		translate: aString
		inDomain: self domain! !

!WALocalizationContext methodsFor: 'accessing' stamp: 'pmm 5/8/2010 22:05'!
translator
	translator isNil ifTrue: [
		translator := GetTextTranslator availableForLocaleID: self localeId ].
	^ translator! !

!String methodsFor: '*seaside-gettext-core' stamp: 'NorbertHartl 6/27/2011 15:30'!
seasideLazyTranslated
	^ WALazyTranslatedString key: self! !

!String methodsFor: '*seaside-gettext-core' stamp: 'pmm 5/15/2010 21:46'!
seasideTranslated
	^ WACurrentLocalizationContext value translate: self! !

!String methodsFor: '*seaside-gettext-core' stamp: 'pmm 5/15/2010 21:47'!
seasideTranslatedTo: aLocale
	^ WACurrentLocalizationContext value translate: self to: aLocale! !

!WALocale methodsFor: '*seaside-gettext-core' stamp: 'pmm 5/7/2010 17:46'!
asLocaleID
	^ LocaleID
		isoLanguage: self language
		isoCountry: self country! !

!WARenderer methodsFor: '*seaside-gettext-core' stamp: 'pmm 5/8/2010 16:09'!
translate: aString
	self text: (WACurrentLocalizationContext value translate: aString)! !

!WARenderer methodsFor: '*seaside-gettext-core' stamp: 'pmm 5/8/2010 16:09'!
translate: aString to: aLocale
	self text: (WACurrentLocalizationContext value translate: aString to: aLocale)! !

!WASession methodsFor: '*seaside-gettext-core' stamp: 'pmm 5/10/2010 22:36'!
defaultLocale
	^ WACurrentLocalizationContext value
		fistSupportedLocaleWithFallback:  [ self fallbackLocale ]! !

!WASession methodsFor: '*seaside-gettext-core' stamp: 'pmm 5/10/2010 22:25'!
fallbackLocale
	^ WALocale
		language: 'en'! !

!WASession methodsFor: '*seaside-gettext-core' stamp: 'pmm 5/7/2010 17:37'!
locale
	^ self properties
		at: #gettextLocale
		ifAbsentPut: [ self defaultLocale ]! !

!WASession methodsFor: '*seaside-gettext-core' stamp: 'pmm 5/8/2010 20:57'!
locale: aLocale
	self properties
		at: #gettextLocale
		put: aLocale! !

WARequestFilter subclass: #WALocalizationContextFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Gettext-Core'!

!WALocalizationContextFilter methodsFor: 'processing' stamp: 'pmm 5/7/2010 17:33'!
handleFiltered: aRequestContext 
	WACurrentLocalizationContext
		use: WALocalizationContext new
		during: [ super handleFiltered: aRequestContext ]! !

!GRPackage class methodsFor: '*seaside-gettext-core' stamp: 'pmm 5/8/2010 15:42'!
seasideGettextCore
	^ self new
		name: 'Seaside-Gettext-Core';
		description: 'i18n and l10n using gettext';
		url: #seasideAddonsUrl;
		yourself! !

!WAApplication methodsFor: '*seaside-gettext-core' stamp: 'pmm 5/8/2010 22:07'!
gettextDomain
	^ self preferenceAt: #gettextDomain! !

WASystemConfiguration subclass: #WAGetTextConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Gettext-Core'!

!WAGetTextConfiguration methodsFor: 'description' stamp: 'pmm 5/8/2010 21:59'!
describeOn: config
	(config string: #gettextDomain)
		label: 'Gettext Domain';
		comment: 'The name of the domain where all lozalized strings should come from.'! !

WADynamicVariable subclass: #WACurrentLocalizationContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Gettext-Core'!
